// SendLightMail.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

/* Defines */
// SHPHONELIB SendLightMail stuff
#define MAX_SENDNUMBER_LEN	36
#define MAX_SENDDATA_LEN	124
#define CSHPHONECLIENTLIB_INSTANCE_SIZE		4
#define SHPHONELIBDLL						_T("shphonelib.dll")
#define CSHPHONECLIENTLIB_CTOR				_T("??0CshphoneClientlib@@QAA@PAUHWND__@@H@Z")
#define CSHPHONECLIENTLIB_DTOR				_T("??1CshphoneClientlib@@QAA@XZ")
#define SENDLIGHTMAIL						_T("?SendLightMail@CshphoneClientlib@@QAAXPAD0@Z")
#define WM_SENDLIGHTMAIL_EVENT				0x632
// KickLightMail stuff
#define LIGHTMAIL_REG_KEY_NAME			_T("Software\\Sharp\\PhoneApp")
#define LIGHTMAIL_REG_VALUE_NAME		_T("LightMail")
#define WM_WAKEUP_LIGHTMAIL				0x1402
#define WPARAM_WAKEUP_LIGHTMAIL			0x1402
#define LPARAM_WAKEUP_LIGHTMAIL			0
// LightMail Common stuff
#define LIGHTMAIL_WINDOW_NAME			_T("Cg[ ")
#define LIGHTMAIL_APP_PATH				_T("\\Windows\\lightmail.exe")
#define LIGHTMAIL_APP_ARG_BACKGROUND	_T("-t")
#define LIGHTMAIL_APP_ARG_EDITWINDOW	_T("-n %s")
// others
#define	MAX_LOADSTRING						100
#define SENDLIGHTMAIL_WINDOW_CLASS_NAME		_T("SENDLIGHTMAIL APPLICATION CLASS")
#define SENDLIGHTMAIL_WINDOW_TITLE_NAME		_T("SENDLIGHTMAIL APPLICATION TITLE")
#define SENDLIGHTMAIL_MUTEX_NAME			_T("SENDLIGHTMAIL APPLICATION MUTEX")
#define SENDLIGHTMAIL_END_TIMERID			666
#define SENDLIGHTMAIL_TIMEOUT				(10*1000)
#define SENDLIGHTMAIL_STATUS_SUCCESS		0x00000000
#define SENDLIGHTMAIL_STATUS_FAIL			0x00000001
#define SENDLIGHTMAIL_STATUS_TIMEOUT		0x00000002

/* Typedefs */
typedef void (__cdecl * PFNCSHPHONECLIENTLIB_CTOR)(void*, struct HWND__ *, int);
typedef void (__cdecl * PFNCSHPHONECLIENTLIB_DTOR)(void*);
typedef void (__cdecl * PFNSENDLIGHTMAIL)(void*, char*, char*);

typedef struct {
	DWORD	dwArgNum;
	TCHAR	szSendNumber[MAX_SENDNUMBER_LEN];
	TCHAR	szSendFileName[MAX_PATH + 1];
} PROGRAM_OPTIONS;

typedef struct {
	char	szSendNumber[MAX_SENDNUMBER_LEN];
	char	szSendData[MAX_SENDDATA_LEN];
} SENDLIGHTMAILINFO;

typedef struct {
	LPBYTE						pInstance;
	HMODULE						hModule;
	PFNCSHPHONECLIENTLIB_CTOR	pfnCshphoneClientlib_Ctor;
	PFNCSHPHONECLIENTLIB_DTOR	pfnCshphoneClientlib_Dtor;
	PFNSENDLIGHTMAIL			pfnSendLightMail;
} SHPHONECLIENTLIBIF;


// Global Variables:
HINSTANCE			g_hInst;				// The current instance
SENDLIGHTMAILINFO	g_sendLightMailInfo;


// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass	(HINSTANCE, LPTSTR);
BOOL				InitInstance	(HINSTANCE, int);
LRESULT CALLBACK	WndProc			(HWND, UINT, WPARAM, LPARAM);

static
void
KickLightMail(
	LPTSTR	pszSendNumber
)
{
	HWND	hWnd = NULL;

	if (pszSendNumber == NULL) {
		return;
	}

	hWnd = FindWindow(NULL, LIGHTMAIL_WINDOW_NAME);

	if (hWnd != NULL) {
		LONG	lResult;
		HKEY	hKey;

		lResult = RegOpenKeyEx(HKEY_CURRENT_USER, LIGHTMAIL_REG_KEY_NAME, 0, 0, &hKey);
		if (lResult == ERROR_SUCCESS) {
			DWORD	dwType;
			DWORD	dwSize;

			dwSize = (_tcslen(pszSendNumber)+1)*sizeof(TCHAR);
			dwType = REG_SZ;

			lResult = RegSetValueEx(hKey, LIGHTMAIL_REG_VALUE_NAME, NULL, dwType, (LPBYTE)pszSendNumber, dwSize);

			if (lResult == ERROR_SUCCESS) {
				PostMessage(hWnd, WM_WAKEUP_LIGHTMAIL, WPARAM_WAKEUP_LIGHTMAIL, LPARAM_WAKEUP_LIGHTMAIL);
			}

			RegCloseKey(hKey);
			hKey = NULL;
		}
	}
	else {
		BOOL	bRet;
		TCHAR	szApplicationPath[MAX_PATH+1];
		TCHAR	szApplicationArgs[MAX_PATH+1];
		PROCESS_INFORMATION pi;

		_tcscpy(szApplicationPath, LIGHTMAIL_APP_PATH);
		wsprintf(szApplicationArgs, LIGHTMAIL_APP_ARG_EDITWINDOW, pszSendNumber);

		memset(&pi, 0, sizeof(pi));

		bRet = ::CreateProcess(
						szApplicationPath,
						szApplicationArgs,
						NULL,
						NULL,
						NULL,
						NULL,
						0,
						NULL,
						NULL,
						&pi);
		if (bRet) {
			CloseHandle(pi.hThread);
			CloseHandle(pi.hProcess);
		}
	}
}

static
BOOL
IsLightMailAppAlive()
{
	BOOL	bRet;
	HWND	hWnd;

	bRet = FALSE;

	hWnd = FindWindow(NULL, LIGHTMAIL_WINDOW_NAME);
	if (hWnd != NULL) {
		bRet = TRUE;
	}

	return bRet;
}

static
BOOL
KillLightMailApp()
{
	int		i;
	BOOL	bRet;
	HWND	hWnd;

	bRet = FALSE;

	hWnd = FindWindow(NULL, LIGHTMAIL_WINDOW_NAME);
	if (hWnd != NULL) {
		PostMessage(hWnd, WM_DESTROY, 0, 0);

		for (i = 0; i < 20; i++) {
			hWnd = FindWindow(NULL, LIGHTMAIL_WINDOW_NAME);
			if (hWnd == NULL) {
				bRet = TRUE;
				break;
			}
			Sleep(200);
		}
	}

	return bRet;
}

static
BOOL
InvokeLightMailApp()
{
	BOOL	bRet;
	PROCESS_INFORMATION pi;
	TCHAR	szLightMailCmd[64];
	TCHAR	szLightMailArg[16];

	memset(&pi, 0, sizeof(pi));

	_tcscpy(szLightMailCmd, LIGHTMAIL_APP_PATH);
	_tcscpy(szLightMailArg, LIGHTMAIL_APP_ARG_BACKGROUND);

	bRet = ::CreateProcess(
					szLightMailCmd,
					szLightMailArg,
					NULL,
					NULL,
					NULL,
					NULL,
					0,
					NULL,
					NULL,
					&pi);

	if (bRet) {
		CloseHandle(pi.hThread);
		CloseHandle(pi.hProcess);
	}

	return bRet;
}

static
SHPHONECLIENTLIBIF*
CreateClientLibIF()
{
	BOOL						bSucc = FALSE;
	HMODULE						hModule = NULL;
	PFNCSHPHONECLIENTLIB_CTOR	pfnCshphoneClientlib_Ctor = NULL;
	PFNCSHPHONECLIENTLIB_DTOR	pfnCshphoneClientlib_Dtor = NULL;
	PFNSENDLIGHTMAIL			pfnSendLightMail = NULL;
	LPBYTE						pInstance = NULL;
	SHPHONECLIENTLIBIF*			pClientLibIF = NULL;

	
	hModule = LoadLibrary(SHPHONELIBDLL);
	if (hModule != NULL) {
		pfnCshphoneClientlib_Ctor = (PFNCSHPHONECLIENTLIB_CTOR) GetProcAddress(hModule, CSHPHONECLIENTLIB_CTOR);
		pfnCshphoneClientlib_Dtor = (PFNCSHPHONECLIENTLIB_DTOR) GetProcAddress(hModule, CSHPHONECLIENTLIB_DTOR);
		pfnSendLightMail = (PFNSENDLIGHTMAIL) GetProcAddress(hModule, SENDLIGHTMAIL);
		
		if (pfnCshphoneClientlib_Ctor != NULL &&
			pfnCshphoneClientlib_Dtor != NULL &&
			pfnSendLightMail != NULL) {

			pInstance = (LPBYTE) malloc(CSHPHONECLIENTLIB_INSTANCE_SIZE);

			if (pInstance != NULL) {
				pClientLibIF = (SHPHONECLIENTLIBIF*) malloc(sizeof(SHPHONECLIENTLIBIF));
				memset(pClientLibIF, 0, sizeof(SHPHONECLIENTLIBIF));
				if (pClientLibIF != NULL) {
					pClientLibIF->pInstance = pInstance;
					pClientLibIF->hModule = hModule;
					pClientLibIF->pfnCshphoneClientlib_Ctor = pfnCshphoneClientlib_Ctor;
					pClientLibIF->pfnCshphoneClientlib_Dtor = pfnCshphoneClientlib_Dtor;
					pClientLibIF->pfnSendLightMail = pfnSendLightMail;

					bSucc = TRUE;
				}
			}
		}
	}

	if (!bSucc) {
		if (pClientLibIF != NULL) {
			free(pClientLibIF);
			pClientLibIF = NULL;
		}
		if (pInstance != NULL) {
			free(pInstance);
			pInstance = NULL;
		}
		if (hModule != NULL) {
			FreeLibrary(hModule);
			hModule = NULL;
		}
	}
	
	return pClientLibIF;
}

static
void
DeleteClientLibIF(
	SHPHONECLIENTLIBIF* pClientLibIF
)
{
	if (pClientLibIF != NULL) {
		if (pClientLibIF->pInstance != NULL) {
			free(pClientLibIF->pInstance);
			pClientLibIF->pInstance = NULL;
		}
		if (pClientLibIF->hModule != NULL) {
			FreeLibrary(pClientLibIF->hModule);
			pClientLibIF->hModule = NULL;
		}
		free(pClientLibIF);
	}
}

static
void
ClientLibCtor(
	SHPHONECLIENTLIBIF* pClientLibIF,	// IN
	HWND	hWnd,	// IN
	int		iID		// IN
)
{
	if (pClientLibIF != NULL) {
		(* pClientLibIF->pfnCshphoneClientlib_Ctor)(pClientLibIF->pInstance, hWnd, iID);
	}
}

static
void
ClientLibDtor(
	SHPHONECLIENTLIBIF* pClientLibIF	// IN
)
{
	if (pClientLibIF != NULL) {
		(* pClientLibIF->pfnCshphoneClientlib_Dtor)(pClientLibIF->pInstance);
	}
}

static
void
ClientLibSendLightMail(
	SHPHONECLIENTLIBIF* pClientLibIF,	// IN
	char*	pszSendNumber,				// IN
	char*	pszSendData					// IN
)
{
	if (pClientLibIF != NULL) {
		(* pClientLibIF->pfnSendLightMail)(pClientLibIF->pInstance, pszSendNumber, pszSendData);
	}
}


static
BOOL
ParseParam(
	LPTSTR lpCmdLine,
	PROGRAM_OPTIONS* pOptions
)
{
	BOOL	bRet;
	LPTSTR	pParam = NULL;
	DWORD	dwArgs = 0;

	bRet = FALSE;

	memset(pOptions, 0, sizeof(PROGRAM_OPTIONS));

	if (lpCmdLine != NULL) {
		pParam = wcstok(lpCmdLine, _T(" "));
		while (pParam != NULL) {
			if (dwArgs == 0) {
				wcscpy(pOptions->szSendNumber, pParam);
			}
			else if (dwArgs == 1) {
				wcscpy(pOptions->szSendFileName, pParam);
				
			}
			dwArgs++;
			pParam = wcstok(NULL, _T(" "));
		}
	}

	if (dwArgs == 1 || dwArgs == 2) {
		pOptions->dwArgNum = dwArgs;
		bRet = TRUE;
	}

	return bRet;

}

static
BOOL
LoadSendDataFromFile(
	LPTSTR	szFileName,	// IN
	LPSTR	pSendData	// OUT
)
{
	BOOL	bRet = FALSE;
	TCHAR	szPath[MAX_PATH + 1];
	HANDLE	hFile = INVALID_HANDLE_VALUE;
	
	bRet = FALSE;

	if (szFileName == NULL || pSendData == NULL) {
		return bRet;
	}

	if (szFileName[0] == TEXT('\\')) {
		_tcscpy(szPath, szFileName);
	}
	else {
		LPTSTR	p = NULL;
		GetModuleFileName(NULL, szPath, sizeof(szPath)/sizeof(szPath[0]));
		p = _tcsrchr(szPath, _T('\\'));
		if (p != NULL) {
			*(p+1) = _T('\0');
			_tcscat(szPath, szFileName);
		}
		else {
			_tcscpy(szPath, szFileName);
		}
	}

	hFile = CreateFile(szPath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if (hFile != INVALID_HANDLE_VALUE) {
		DWORD	dwReaded;
		char	szSendData[MAX_SENDDATA_LEN];

		memset(szSendData, 0, sizeof(szSendData));
		bRet = ReadFile(hFile, szSendData, sizeof(szSendData)-1, &dwReaded, NULL);
		if (bRet) {
			strcpy(pSendData, szSendData);
		}

		CloseHandle(hFile);
		hFile = NULL;
	}

	return bRet;

}

static
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS	wc;

    wc.style			= 0;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= 0;
    wc.hCursor			= 0;
    wc.hbrBackground	= 0;
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= szWindowClass;

	return RegisterClass(&wc);
}

static
BOOL
InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND	hWnd = NULL;
	TCHAR	szTitle[MAX_LOADSTRING];			// The title bar text
	TCHAR	szWindowClass[MAX_LOADSTRING];		// The window class name

	g_hInst = hInstance;		// Store instance handle in our global variable
	// Initialize global strings
	lstrcpy(szWindowClass,	SENDLIGHTMAIL_WINDOW_CLASS_NAME);
	lstrcpy(szTitle,		SENDLIGHTMAIL_WINDOW_TITLE_NAME);

	//If it is already running, then focus on the window
	hWnd = FindWindow(szWindowClass, szTitle);	
	if (hWnd) {
		return FALSE;
	} 

	//When the main window is created using CW_USEDEFAULT the height of the menubar (if one
	MyRegisterClass(hInstance, szWindowClass);
	
	hWnd = CreateWindow(szWindowClass, szTitle, 0,
		0, 0, 0, 0, NULL, NULL, hInstance, NULL);
	if (!hWnd) {	
		return FALSE;
	}

	return TRUE;
}

static
int
KickLightMailProc(
	HINSTANCE	hInstance,
	int			nCmdShow,
	PROGRAM_OPTIONS*	pProgramOptions
)
{

	if (pProgramOptions != NULL) {
		KickLightMail(pProgramOptions->szSendNumber);
	}

	return 0;

}

static
int
SendLightMailProc(
	HINSTANCE	hInstance,
	int			nCmdShow,
	PROGRAM_OPTIONS*	pProgramOptions
)
{
	MSG		msg;
	BOOL	bLightMailAppAlive = TRUE;
	char	szSendNumber[36];
	char	szSendData[124];
	int		iRet;

	iRet = 0;	// default return value

	if (pProgramOptions == NULL) {
		return 0;
	}

	memset(szSendNumber, 0, sizeof(szSendNumber));
	WideCharToMultiByte(CP_ACP, 0, pProgramOptions->szSendNumber, -1, szSendNumber, sizeof(szSendNumber), NULL, NULL);

	memset(szSendData, 0, sizeof(szSendData));
	if (LoadSendDataFromFile(pProgramOptions->szSendFileName, szSendData)) {

		memset(&g_sendLightMailInfo, 0, sizeof(g_sendLightMailInfo));
		strcpy(g_sendLightMailInfo.szSendNumber, szSendNumber);
		strcpy(g_sendLightMailInfo.szSendData, szSendData);

		bLightMailAppAlive = IsLightMailAppAlive();
		if (bLightMailAppAlive) {
			if (!KillLightMailApp()) {
				MessageBox(NULL, TEXT("Cg[Av̏IɎs܂"), TEXT("SendLightMail"), MB_OK|MB_SETFOREGROUND);
				return 0;
			}
		}

		if (InitInstance (hInstance, nCmdShow)) {
			// Main message loop:
			while (GetMessage(&msg, NULL, 0, 0)) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}

			iRet = msg.wParam;
		}

		// Cg[AvIĂꍇ͍ċN
		if (bLightMailAppAlive) {
			InvokeLightMailApp();
		}
		//
	}

	return iRet;
}


int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{	

 	BOOL			bParseSucc	= FALSE;
	int				iRet		= 0;
	HANDLE			hMutex		= NULL;
	PROGRAM_OPTIONS	programOptions;

	// dN`FbN
	hMutex = CreateMutex(NULL, TRUE, SENDLIGHTMAIL_MUTEX_NAME);
	if (hMutex != NULL) {
		if (GetLastError() == ERROR_ALREADY_EXISTS) {

			MessageBox(NULL, TEXT("ɋNł"), TEXT("SendLightMail"), MB_OK|MB_SETFOREGROUND);

			CloseHandle(hMutex);
			hMutex = NULL;
			return FALSE;
		}
	}
	else {
		return FALSE;
	}
	//

	bParseSucc = ParseParam(lpCmdLine, &programOptions);
	if (bParseSucc) {
		switch(programOptions.dwArgNum) {
		case 1:
			iRet = KickLightMailProc(hInstance, nCmdShow, &programOptions);
			break;
		case 2:
			iRet = SendLightMailProc(hInstance, nCmdShow, &programOptions);
			break;
		}
	}

	ReleaseMutex(hMutex);
	CloseHandle(hMutex);
	hMutex = NULL;
	return iRet;
}

static
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static	SHPHONECLIENTLIBIF*	s_pClientLibIF		= NULL;
	static  HANDLE				s_hDebugFile		= INVALID_HANDLE_VALUE;
	static	DWORD				s_dwSendStatus		= SENDLIGHTMAIL_STATUS_TIMEOUT;

	switch (message) 
	{
		case WM_CREATE:

			s_pClientLibIF = CreateClientLibIF();

			if (s_pClientLibIF != NULL) {
#ifdef DEBUG
				s_hDebugFile = CreateFile(L"sendlightmail.log", GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL);
#endif
				ClientLibCtor(s_pClientLibIF, hWnd, 0);
	
				SetTimer(hWnd, SENDLIGHTMAIL_END_TIMERID, SENDLIGHTMAIL_TIMEOUT, 0);

				ClientLibSendLightMail(s_pClientLibIF, g_sendLightMailInfo.szSendNumber, g_sendLightMailInfo.szSendData);

			}
			break;

		case WM_TIMER:
			{
				KillTimer(hWnd, SENDLIGHTMAIL_END_TIMERID);
				::SendMessage(hWnd, WM_CLOSE, 0, 0);
			}
			break;

		case WM_DESTROY:
			switch(s_dwSendStatus) {
			case SENDLIGHTMAIL_STATUS_TIMEOUT:
				MessageBox(hWnd, TEXT("M^CAEg܂"), TEXT("SendLightMail"), MB_OK|MB_SETFOREGROUND);
				break;
			case SENDLIGHTMAIL_STATUS_SUCCESS:
#if 0
				MessageBox(hWnd, TEXT("Mɐ܂"), TEXT("SendLightMail"), MB_ICONINFORMATION|MB_OK|MB_SETFOREGROUND);
#endif
				break;
			case SENDLIGHTMAIL_STATUS_FAIL:
				MessageBox(hWnd, TEXT("MɎs܂"), TEXT("SendLightMail"), MB_OK|MB_SETFOREGROUND);
				break;
			}
 
			if (s_pClientLibIF != NULL) {
				ClientLibDtor(s_pClientLibIF);
				DeleteClientLibIF(s_pClientLibIF);
				s_pClientLibIF = NULL;
#ifdef DEBUG
				CloseHandle(s_hDebugFile);
				s_hDebugFile = NULL;
#endif
			}
			PostQuitMessage(0);
			break;

		case WM_SENDLIGHTMAIL_EVENT:
			{
#ifdef DEBUG
				TCHAR	szFormat[256];
				DWORD	dwDummy;

				wsprintf(szFormat, _T("msgId=%08x, wParam=%08x, lParam=%08x\r\n"), message, wParam, lParam);
				if (s_hDebugFile != INVALID_HANDLE_VALUE) {
					WriteFile(s_hDebugFile, szFormat, wcslen(szFormat)*sizeof(WCHAR), &dwDummy, NULL); 
				}
#endif

				if (wParam == 0x2be) {
					// M
					s_dwSendStatus	= SENDLIGHTMAIL_STATUS_SUCCESS;
					SetTimer(hWnd, SENDLIGHTMAIL_END_TIMERID, 10, 0);	// Context؂ւ(Ô)
				}
				else if (wParam == 0x2c1) {
					// Ms
					s_dwSendStatus	= SENDLIGHTMAIL_STATUS_FAIL;
					SetTimer(hWnd, SENDLIGHTMAIL_END_TIMERID, 10, 0);	// Context؂ւ(Ô)
				}
			}
			break;

		default:
			{
#ifdef DEBUG
				if (message >= WM_USER) {
					TCHAR	szFormat[256];
					DWORD	dwDummy;

					wsprintf(szFormat, _T("msgId=%08x, wParam=%08x, lParam=%08x\r\n"), message, wParam, lParam);
					if (s_hDebugFile != INVALID_HANDLE_VALUE) {
						WriteFile(s_hDebugFile, szFormat, wcslen(szFormat)*sizeof(WCHAR), &dwDummy, NULL); 
					}
				}
#endif
			}
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}
